﻿using System;
using System.Windows.Forms;
using Telerik.WinControls;
using Telerik.WinControls.Themes;
using Telerik.WinControls.UI;
using System.Drawing;
using System.Collections.Generic;

namespace Adding_some_separator_in_the_list
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            Office2010SilverTheme office2010Silver = new Office2010SilverTheme();
            ThemeResolutionService.ApplicationThemeName = "Office2010Silver";

            List<string> dataItems = new List<string>();

            dataItems.Add("NoFilter");
            dataItems.Add("");
            dataItems.Add("Running Sale Process (Enum value 15)");
            dataItems.Add("Financial Dtp Sale Process (Enum valu 12)");
            dataItems.Add("");
            dataItems.Add("Process Step 1 (Enum value 1)");
            dataItems.Add("Process Step 2 (Enum value 2)");
            dataItems.Add("Process Step 3 (Enum value 4)");
            dataItems.Add("Process Step 4 (Enum value 8)");
            dataItems.Add("");
            dataItems.Add("Closed Sale Process (Enum value 0)");

            this.radDropDownList1.DataSource = dataItems;

            this.radDropDownList1.DropDownStyle = Telerik.WinControls.RadDropDownStyle.DropDownList;

            this.radDropDownList1.AutoSizeItems = true;

            this.radDropDownList1.VisualListItemFormatting += new Telerik.WinControls.UI.VisualListItemFormattingEventHandler(radDropDownList1_VisualListItemFormatting);
        }

        void radDropDownList1_VisualListItemFormatting(object sender, Telerik.WinControls.UI.VisualItemFormattingEventArgs args)
        {
            RadListVisualItem item = args.VisualItem;
            if (item != null)
            {
                if (args.VisualItem.Data.IsDataBound)
                {
                    Console.WriteLine(args.VisualItem.Data.DataBoundItem);
                }
                if (item.Text == "")
                {
                    item.Enabled = false;
                    item.UseDefaultDisabledPaint = false;
                    item.Padding = new System.Windows.Forms.Padding(0);
                    item.DrawBorder = false;

                    // Use this code or use BackgroundImage if it suits oyu better
                    item.ShowHorizontalLine = true;
                    item.HorizontalLineWidth = 2;
                    item.HorizontalLineColor = Color.Red;

                    //item.BackgroundImage = Image.FromFile(@"..\..\Separator.png");
                }
                else
                {
                    item.ResetValue(RadListVisualItem.EnabledProperty, ValueResetFlags.Local);
                    item.ResetValue(RadListVisualItem.UseDefaultDisabledPaintProperty, ValueResetFlags.Local);
                    item.ResetValue(RadListVisualItem.PaddingProperty, ValueResetFlags.Local);
                    item.ResetValue(RadListVisualItem.DrawBorderProperty, ValueResetFlags.Local);

                    item.ResetValue(RadListVisualItem.ShowHorizontalLineProperty, ValueResetFlags.Local);
                    item.ResetValue(RadListVisualItem.HorizontalLineWidthProperty, ValueResetFlags.Local);
                    item.ResetValue(RadListVisualItem.HorizontalLineColorProperty, ValueResetFlags.Local);

                    // If the BackgroundImage property have been set the line below should be uncommented also
                    //item.ResetValue(RadListVisualItem.BackgroundImageProperty, Telerik.WinControls.ValueResetFlags.Local);
                }
            }
        }
    }
}
